﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ShoppingCartGUIClient.ShoppingCartService;

namespace ShoppingCartGUIClient
{
    public partial class MainWindow : Window
    {
        private ShoppingCartServiceClient proxy = null;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            // Connect to the ShoppingCartService service 
            proxy = new ShoppingCartServiceClient("WS2007HttpBinding_IShoppingCartService");
        }

        private void Window_Unloaded(object sender, RoutedEventArgs e)
        {
            // Disconnect from the service
            proxy.Close();
        }

        // Add the item specified in the productNumber Text Box to the shopping cart
        private void addItem_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Add the item to the shoppping cart
                proxy.AddItemToCart(productNumber.Text);

                // Display the shopping cart
                string cartContents = proxy.GetShoppingCart();
                shoppingCartContents.Text = cartContents;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error adding item to cart", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        // Remove the item specified in the productNumber Text Box from the shopping cart
        private void removeItem_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Remove the item from the shoppping cart
                proxy.RemoveItemFromCart(productNumber.Text);

                // Display the shopping cart
                string cartContents = proxy.GetShoppingCart();
                shoppingCartContents.Text = cartContents;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error removing item from cart", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        // Checkout
        private void checkout_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                proxy.Checkout();

                // Clear the shopping cart displayed in the window
                shoppingCartContents.Clear();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error checking out", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
